<?php
/*
Plugin Name: So-and-so Said...
Plugin URI: http://wordpress.org/extend/plugins/so-and-so-said/
Description: Replaces "So and so said..." (on the comments page) with an applicable verb -- such as "So and so exclaimed," "So and so pondered," etc.
Version: 1.0.0
Author: Josiah McClurg
Author URI: http://josiahland.com/
*/

// returns the pathname to the script that will
// modify your comments page -- see comments.php in
// this directory for more information
function so_and_so_said()
{
   $t = dirname(__FILE__)."/comments.php";
   return($t);
}

// leaves a handy dandy tag so that it's easy to find
// where the author is located on the page -- it only
// works when the function get_comment_author_link is
// called by your theme
function so_and_so_author()
{
	global $comment;
	$url    = get_comment_author_url();
	$author = get_comment_author();

	if ( empty( $url ) || 'http://' == $url )
		$return = $author;
	else
		$return = "<a href='$url' rel='external nofollow'>$author</a>";
	return ($return."<!--#_A_#-->");
}

// makes handy dandy begin and end tags for the comment text
function so_and_so_comment($content)
{
   return("<!--#_S_#-->".$content."<!--#_E_#-->");
}

// register filters with wordpress
add_filter( 'comment_text', 'so_and_so_comment');
add_filter( 'get_comment_author_link', 'so_and_so_author');
add_filter( 'comments_template', 'so_and_so_said' );

?>
