<?php
/*
Plugin Name: Linknotes
Version: 0.5
Plugin URI: http://jeremycurry.com/archives/2005/08/07/linknotes/
Description: Add Link notes to your posts. Simply Go :"Jeremy Curry(The guy who made linknotes)":http://jeremycurry.com , and then a superscript will show up wherever you put that code, and at the bottom of your post, this will follow: <br /><sup>1</sup><a href="http://jeremycurry.com">Jeremy Curry</a> - The guy who made linknotes
Author: Jeremy Curry
Author URI: http://jeremycurry.com

Add Linknotes to your posts. Simply Go
:"Jeremy Curry(The guy who made linknotes)":http://jeremycurry.com
and then a superscript will show up wherever you put that code, and at the bottom of your post, this will follow:
1<a href="http://jeremycurry.com">Jeremy Curry</a> - The guy who made linknotes

*CHANGES*
v0.5 - Aug 11 2004 01:32 EST
* Added notes, item, and description templates for more customization
* Linknotes show up in an ordered list by default
* Added footnote functionality, just remove the title and url - :"(This is a footnote)":
* Removed a bunch of excess code
* Fixed a few javascript issues with buttons
* Thanks for Chris J. Davis for some ideas www.chrisjdavis.org
v0.4a - Aug 9 2005 15:11 EST
* Added javascript to superscript links in footnote section, to allow easier maneuverability in Bloglines (and other aggregators that allow extra attributes, but open links in new window) 
v0.4 - Aug 9 2005 13:52 EST
* Changed the format in the "CHANGES" section of the file, so I can just copy and paste to and from my blog, and textile will do the rest!
* Changed and added some code bits. Nothing to really notice
* Changed $lnCfg['seperate'] to $lnCfg['item_begin'] and $lnCfg['item_end']
* Added javascript to make sure the superscript link is executed within the same window (Because Bloglines messes up) This Totally messes with textile use of the underscore
v0.3a - Aug 8 2005 14:20 EST
* Added quicktag selection support. The selected text will be set as your Title. Tested in Firefox and IE.
v0.3 - Aug 8 2005 13:00 EST
* Added 2 buttons to quicktags. Add Linknote [linknote], and Add Linknote with Description [linknote+desc]
v0.2 - Aug 8 2005
* In superscript anchor tag, replaced the HREF attribute with actual link URI. Used JavaScript to re-write href to go to linknotes. Used to compensate when RSS agregators remove attributes
* Added Title and description of Linknote to the Title attribute in the superscript Anchor.
* Added a  hyphen (-) to seperate the post number, and the number of the linknote in the ID's used to jump to and from the Linknotes
* Wrapped Linknotes into a <div></div> tag with the CSS class alt
*/

$lnCfg['notes_code'] = '<br /><div class="alt">Linknotes:<br /><ol>%items%</ol></div>';
$lnCfg['item_code']	 = '<li id="%noted-id%"><a href="%url%">%title%</a> %desc% <a href="%return%"><strong>&#8617;</strong></a>';

// This is only shows up if there is a description
$lnCfg['desc_code']	 = ' - %desc_text%';

// Toggle quicktag buttons
$lnCfg['ln_button'] = true;
$lnCfg['ln_desc_button'] = false;
$lnCfg['ln_footnote_button'] = true;

/* You can stop Editing Here */


$lnCfg = (object) $lnCfg;

class linknotes
{

  function linkify($text) {
				$text = preg_replace_callback('/
						:"                            # start
            ([^"]+)?                      # $desc
            \s?
            (?:\(([^)]+)\)(?="))?        # $title
            ":
            (\S+\b)?                     # $url
            (\/)?                        # $slash
            ([^\w\/;]*)                  # $post
            (?=\s|$)
        /Ux', array(&$this, "linkd"), $text);
				
				if ($this->are_links) {
					for ($i=1; $i <= $this->count; $i++) {
						$links .= $this->items[$i];
					}

					$linknotes = str_replace('%items%', $links, $this->notes_code);
					$text = $text.$linknotes;
				}
				
				return $text;
    }
		
		function linkd($m) {
				list(, $title, $text, $url, $slash, $post) = $m;
				$this->count++;
		 		$this->are_links = true;

				$itm_replace = array('%noted-id%', '%url%','%title%','%desc%', '%desc_text%', '%return%');

				$desc = $text;
				if ($text && $url) $desc = str_replace('%desc_text%', $text, $this->desc_code);

				$itm = array( "linknote-$this->id-$this->count", $url, $title, $desc, $text, "#noted-$this->id-$this->count");

				$this->items[$this->count] = str_replace($itm_replace, $itm, $this->item_code);

				$at_title = strip_tags($title.$desc);
        return "<sup><a href=\"$url\" onclick=\"this.target='_self';this.href='#linknote-".$this->id.'-'.$this->count."';\" id=\"noted-$this->id-$this->count\" title=\"$at_title\">[$this->count]</a></sup>";
    }

    function shelve($val) {
        $this->shelf[] = $val;
        return ' <' . count($this->shelf) . '>';
    }
}

function linknotes( $string ) {
		global $lnCfg,$id;
    $ln = new linknotes;
		
		$ln->id				= $id;		

		$ln->notes_code = $lnCfg->notes_code;
		$ln->item_code  = $lnCfg->item_code;
		$ln->desc_code	= $lnCfg->desc_code;				
		
    return $ln->linkify($string); //$string
}

function linknote_add_button() {
	global $lnCfg;
	if(strpos($_SERVER['REQUEST_URI'], 'post.php'))
	{
?>
<script language="JavaScript" type="text/javascript"><!--
var toolbar = document.getElementById("ed_toolbar");
<?php
		if ($lnCfg->ln_button)
  		edit_insert_button("LN", "linknote_button", "Add Linknote");
		if ($lnCfg->ln_desc_button)
  		edit_insert_button("LN+desc", "linknote_desc_button", "Add Linknote with Description");
		if ($lnCfg->ln_footnote_button)
			edit_insert_button("LN-Footnote", "linknote_footnote_button", "Add Linknote with Description");
	
?>


function linknote_button() {
  var url = prompt("Enter the URL","http://");
	if (url) {
    if (document.selection) {
    	var selectedText = document.selection;
  		var newRange = selectedText.createRange();
    	edCanvas.focus();
    	title = newRange.text;
  	} else if (edCanvas.selectionStart || edCanvas.selectionStart == '0') {
    	var startPos = edCanvas.selectionStart;
  		var endPos = edCanvas.selectionEnd;
  		var cursorPos = endPos;
  		title = edCanvas.value.substring(startPos, endPos)
  	} else if (title == '') {		
  		var title = prompt("Enter the Title","");
		}

  		linknote = ':"'+title+'":'+url
  	
  	edInsertContent(edCanvas, linknote);
	}
}

function linknote_desc_button() {
  var url = prompt("Enter the URL","http://");
	if (url) {
  	if (document.selection) {
    	var selectedText = document.selection;
  		var newRange = selectedText.createRange();
    	edCanvas.focus();
    	title = newRange.text;
  	} else if (edCanvas.selectionStart || edCanvas.selectionStart == '0') {
    	var startPos = edCanvas.selectionStart;
  		var endPos = edCanvas.selectionEnd;
  		var cursorPos = endPos;
  		title = edCanvas.value.substring(startPos, endPos)
  	} else if (title == '') {		
  		var title = prompt("Enter the Title","");
		}
		
  	var desc = prompt("Enter the Description/Reference","");
  	
  	if (desc) {
  		linknote = ':"'+title+'('+desc+')":'+url
  	} else {
  		linknote = ':"'+title+'":'+url
  	}
  	
  	edInsertContent(edCanvas, linknote);
	}
}

function linknote_footnote_button() {
    if (document.selection) {
    	var selectedText = document.selection;
  		var newRange = selectedText.createRange();
    	edCanvas.focus();
    	footnote = newRange.text;
  	} else if (edCanvas.selectionStart || edCanvas.selectionStart != '0') {
    	var startPos = edCanvas.selectionStart;
  		var endPos = edCanvas.selectionEnd;
  		var cursorPos = endPos;
  		footnote = edCanvas.value.substring(startPos, endPos)
  	} else if (footnote == '') {		
  		var footnote = prompt("Enter footnote","");
		}

  		linknote = ':"('+footnote+')":'
  	
  	edInsertContent(edCanvas, linknote);
}

//--></script>
<?php
	}
}

if(!function_exists('edit_insert_button'))
{
	//edit_insert_button: Inserts a button into the editor
	function edit_insert_button($caption, $js_onclick, $title = '')
	{
	?>
	if(toolbar)
	{
		var theButton = document.createElement('input');
		theButton.type = 'button';
		theButton.value = '<?php echo $caption; ?>';
		theButton.onclick = <?php echo $js_onclick; ?>;
		theButton.className = 'ed_button';
		theButton.title = "<?php echo $title; ?>";
		theButton.id = "<?php echo "ed_{$caption}"; ?>";
		toolbar.appendChild(theButton);
	}
	<?php

	}
}

add_filter('admin_footer', 'linknote_add_button');
add_filter('the_content', 'linknotes', 4);