<?php
define (THEMENAME,'evening-sun');

load_theme_textdomain(THEMENAME);

add_action ('init',create_function('','global $spectacula; $spectacula = new spectaculaTheme();'));

class spectaculaTheme {

	var $options;

	function spectaculaTheme(){
		global $wp_version;
		

		// Some simple fixes and hacks.
		add_filter('body_class',array($this,'get_agent_body_class'));

		if (function_exists('automatic_feed_links'))
			automatic_feed_links();
		else
			add_action('wp_head',array($this, 'extraRSSFeeds'));

		add_action('wp',array($this,'before_headers'));
		// Set max width for post images
		add_action('editor_max_image_size',create_function('','return array(580,0);'));

//		add_filter('the_excerpt',array($this,'excerpt_more_link'));
//		add_filter('wp_list_categories',array($this,'category_count_fix'));

		// If my sometoggles.php is included then lets add some toggles.
		if (function_exists('add_page_toggle') || function_exists('add_post_toggle'))  {
			add_page_toggle(__('Link to this on the tab bar', THEMENAME),'header');
			add_page_toggle(__('Link to this in the footer', THEMENAME), 'footer');
			add_post_toggle(__('Hide the title', THEMENAME), 'hidetitle');
			add_page_toggle(__('Hide the title', THEMENAME), 'hidetitle');
		}

		// Register sidebars
		if ( function_exists('register_sidebar') ) {
			register_sidebar(array(
				'name' => 'Sidebar',
				'id' => 'sidebar-1',
				'before_widget' =>	'<div class="widget %2$s"><span class="widgetTop"></span><div class="widgetCentre">',
				'after_widget' =>	'</div><span class="widgetBottom"></span></div>',
				'before_title' =>	'<strong class="widgetTitle">',
				'after_title' =>	'</strong>'
			));
		}
		
		// Create options menu in 2.7+
		if (version_compare($wp_version, '2.7', 'ge'))
			add_action('admin_menu', array($this, 'optionsAddPage'));
			

		$defaultOptions = array('comments_nest_depth' => 1,);
		$this->options = array_merge($defaultOptions, (array)get_option('spectacula_theme_options'));
	}

	// Add some jQuery bits to the site.
	function before_headers(){
		global $wp_version;

		if(function_exists('wp_list_comments') && is_singular())
			wp_enqueue_script('comment-reply');

		// Only add jQuery to wp 2.5 an above.
		if (!is_admin() && version_compare($wp_version, '2.5', 'ge')) {
			wp_enqueue_script('behaviour',get_bloginfo('template_url').'/js/behaviour.min.js',array('jquery'),1.0);
			wp_localize_script('behaviour','behaviourL10n',array(
				'searchError'	=> __('Oops! Try again.', THEMENAME),
				'searchPrompt'	=> __('Search', THEMENAME),
				'trackbackShowText' => __('Show trackbacks', THEMENAME),
				'trackbackHideText' => __('Hide trackbacks', THEMENAME),
				'replyHideMany' => __("Hide %count% replies to %name% comment", THEMENAME),
				'replyShowMany' => __("View %count% replies to %name% comment", THEMENAME),
				'replyHideOne' => __("Hide the reply to %name% comment", THEMENAME),
				'replyShowOne' => __("View the reply to %name% comment", THEMENAME),
				'nestDepth' => $this->options['comments_nest_depth'] // The depth at which to start collapsing comments.
			));
		}
	}

	// Change the [...] item at the bottom of the excerpt to a more useful link.
	function excerpt_more_link($content = '') {
		$replacement = '<span class="more_link_small"><a href="'.get_permalink().'"> '.__('Read more', THEMENAME).'</a></span>';
		$content = str_replace(array('[&#8230;]','[...]'),'&#8230;',$content);
		return $content.$replacement;
	}

	// Move the category count to inside the anchor. Otherwise formatting done on the anchor can be messed up when the option is turned on.
	function category_count_fix($content) {
		$content = preg_replace('/<\/a>[^\(<]*(\(\d*\))/i','&nbsp;&nbsp;<span class="category_count">$1</span></a>',$content);
		return $content;
	}

	// This is in no way comprehensive but does help to ident IE for style sheet hacking.
	function get_agent_body_class($class = array()){
		$useragent = getenv('HTTP_USER_AGENT');

		if(preg_match('!gecko/\d+!i',$useragent))
			$class[] = 'gecko';
		elseif(preg_match('!(applewebkit|konqueror)/[\d\.]+!i',$useragent))
			$class[] = 'webkit';
		elseif (preg_match('!msie\s+(\d+\.\d+)!i',$useragent,$match)) {
			$class[] = 'ie';
			$version = floatval($match[1]);

			/* Add an identifier for IE versions. */
			if ($version >= 9)						array_push($class,'ienew');
			if ($version >= 8 &&	$version < 9)	array_push($class,'ie8');
			if ($version >= 7 &&	$version < 8)	array_push($class,'ie7');
			if ($version >= 6 &&	$version < 7)	array_push($class,'ie6');
			if ($version >= 5.5 &&	$version < 6)	array_push($class,'ie55');
			if ($version >= 5 &&	$version < 5.5)	array_push($class,'ie5');
			if ($version < 5) 						array_push($class,'ieold');
		}

		return $class;
	}

	function extraRSSFeeds() {?>
		<link rel="alternate" type="application/rss+xml" title="<?php bloginfo("name");?> &raquo; <?php _e("global feed", THEMENAME)?>" href="<?php bloginfo("rss2_url");?>" /><?php

		global $post, $wp_version,$post;

		if (version_compare($wp_version, '2.8', 'ge') || version_compare($wp_version, '2.1', 'le') ) // WP 2.1 will fail with most of this and 2.8 has other ways.
			return true;

		if ((comments_open() || get_comments_number() > 0) && (!is_attachment() && (is_single()|| is_page()))) {
		?>	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo("name");_e(" &raquo; comments feed", THEMENAME);?>" href="<?php echo get_post_comments_feed_link($post->ID);?>"/><?php
		} elseif (is_search() && function_exists('get_search_feed_link')) {
			$search = attribute_escape(get_search_query());
			if (!empty($search))
		?>	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo("name");printf(__(" &raquo; search &quot;%s&quot;", THEMENAME), $search);?>" href="<?php echo get_search_feed_link()?>"/><?php
		} elseif(is_category() && function_exists('get_category_feed_link')) {
			global $cat;
		?>	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo("name");printf(__(" &raquo; category &quot;%s&quot;", THEMENAME), get_catname($cat));?>" href="<?php echo get_category_feed_link($cat)?>"/><?php
		} elseif(is_tag() && function_exists('is_tag')) {
			global $tag;
			$term = is_term($tag,'post_tag');
		?>	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo("name");printf(__(" &raquo; tag &quot;%s&quot;", THEMENAME), $tag);?>" href="<?php echo get_tag_feed_link($term["term_id"])?>"/><?php
		}

		return true;
	}
	
	function optionsAddPage() {
		register_setting('spectacula_theme_options', 'spectacula_theme_options', array($this, 'optionsValidate'));
		add_theme_page(__('Evening Sun Options', THEMENAME), __('Evening Sun Options', THEMENAME), 'manage_options', THEMENAME, array($this, 'optionsPage'));
	}
	
	function optionsPage() {
	?>
	<div class="wrap">
		<h2><?php _e('Evening Sun Options', THEMENAME)?></h2>
		<form method="post" action="options.php">
			<?php settings_fields('spectacula_theme_options'); ?>

			<?php $options = get_option('spectacula_theme_options'); ?>
			<table class="form-table">
				<tr valign="top"><th scope="row"><label><?php _e('The depth at which to start collapsing comments.', THEMENAME); ?></label></th>
					<td>
						<select name="spectacula_theme_options[comments_nest_depth]">
							<option value="1"<?php echo intval($options['comments_nest_depth']) == 1 ? ' selected="selected"' : '';?>>1</option>
							<option value="2"<?php echo intval($options['comments_nest_depth']) == 2 ? ' selected="selected"' : '';?>>2</option>
							<option value="3"<?php echo intval($options['comments_nest_depth']) == 3 ? ' selected="selected"' : '';?>>3</option>
							<option value="4"<?php echo intval($options['comments_nest_depth']) == 4 ? ' selected="selected"' : '';?>>4</option>
							<option value="5"<?php echo intval($options['comments_nest_depth']) == 5 ? ' selected="selected"' : '';?>>5</option>
							<option value="6"<?php echo intval($options['comments_nest_depth']) == 6 ? ' selected="selected"' : '';?>>6</option>
							<option value="7"<?php echo intval($options['comments_nest_depth']) == 7 ? ' selected="selected"' : '';?>>7</option>
							<option value="8"<?php echo intval($options['comments_nest_depth']) == 8 ? ' selected="selected"' : '';?>>8</option>
							<option value="9"<?php echo intval($options['comments_nest_depth']) == 9 ? ' selected="selected"' : '';?>>9</option>
							<option value="10"<?php echo intval($options['comments_nest_depth']) == 10 ? ' selected="selected"' : '';?>>10</option>
						</select>
					</td>
				</tr>
			</table>
			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes', THEMENAME) ?>" />
			</p>
		</form>
	</div>
	<?php	
	}
	
	function optionsValidate($options) {
		$options['comments_nest_depth'] = intval($options['comments_nest_depth']) > 0 || intval($options['comments_nest_depth']) < 11 ? intval($options['comments_nest_depth']) : 1;
		return $options;
	}
}

/*
 I call this from within the body tag to add a couple of classes to it to help
 me with the CSS in certain browsers, namely IE.
 Seems this function has been added to wp2.8. I've split out the user agent
 sniffing into another function and added that to the new filter.
*/
if (!function_exists('body_class')) {
	function body_class() {
		if (is_page())			$class[] = 'page';
		if (is_home())			$class[] = 'home';
		if (is_single())		$class[] = 'single';
		if (is_category())		$class[] = 'category';
		if (is_author())		$class[] = 'author';
		if (is_search())		$class[] = 'search';
		if (is_date())			$class[] = 'date';
		if (is_year())			$class[] = 'year';
		if (is_month())			$class[] = 'month';
		if (is_day())			$class[] = 'day';
		if (is_time())			$class[] = 'time';
		if (is_404())			$class[] = 'error404';
		if (is_paged())			$class[] = 'paged';
		if (is_attachment())	$class[] = 'attachment';
		if (is_archive() && !is_category()) $class[] = 'archive';

		$class = apply_filters('body_class',$class);

		$class = implode(' ',$class);
		if (!empty($class)) {
			echo " class=\"$class\"";
		}
	}
}

if (!function_exists('post_class')) {
	function post_class($class) {

		if (is_array($class))
			$class = implode(' ',$class);
		echo " class=\"$class\"";
	}
}
?>