(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    111701,       2744]
NotebookOptionsPosition[    110150,       2701]
NotebookOutlinePosition[    110495,       2716]
CellTagsIndexPosition[    110452,       2713]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Let", " ", 
     RowBox[{"fn", "[", "x", "]"}], " ", "be", " ", "the", " ", "number", " ",
      "of", " ", "possible", " ", "move", " ", "sequences", " ", "of", " ", 
     "length", " ", 
     RowBox[{"(", 
      RowBox[{"x", "-", "1"}], ")"}], " ", "starting", " ", "from", " ", 
     "square", " ", 
     RowBox[{
     "n", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", "Also"}]}], ",", 
    " ", 
    RowBox[{
    "let", " ", "An", " ", "be", " ", "the", " ", "set", " ", "of", " ", 
     "immediate", " ", "possible", " ", "\"\<next move\>\"", " ", "squares"}],
     ",", " ", 
    RowBox[{"from", " ", "square", " ", 
     RowBox[{"n", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", "Then"}],
      " ", 
     RowBox[{"fn", "[", "0", "]"}], " ", "is", " ", "the", " ", "number", " ",
      "of", " ", "squares", " ", "in", " ", 
     RowBox[{
     "An", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", "And"}]}], ",", 
    " ", 
    RowBox[{
     RowBox[{
      RowBox[{"fn", "[", "x", "]"}], " ", "for", " ", "x"}], " ", ">", " ", 
     RowBox[{"0", " ", "is", " ", "sum", " ", "of", " ", 
      RowBox[{"fi", "[", 
       RowBox[{"x", "-", "1"}], "]"}], " ", "for", " ", "each", " ", "square",
       " ", "i", " ", "in", " ", "An"}]}]}], "\[IndentingNewLine]", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"S0", "[", "x_", "]"}], " ", ":=", " ", 
     RowBox[{"2", "*", 
      RowBox[{"f5", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s0", "[", "x_", "]"}], " ", ":=", " ", 
     RowBox[{"S0", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f0", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s0", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S1", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"f2", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f7", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f6", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s1", "[", "x_", "]"}], ":=", 
     RowBox[{"S1", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f1", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"3", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s1", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S2", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"f8", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f5", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f1", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f6", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s2", "[", "x_", "]"}], ":=", 
     RowBox[{"S2", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f2", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"4", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s2", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S3", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"f4", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f7", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f5", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f8", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s3", "[", "x_", "]"}], ":=", 
     RowBox[{"S3", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f3", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"4", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s3", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S4", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"2", "*", 
       RowBox[{"f3", "[", 
        RowBox[{"x", "-", "1"}], "]"}]}], "+", 
      RowBox[{"2", "*", 
       RowBox[{"f8", "[", 
        RowBox[{"x", "-", "1"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s4", "[", "x_", "]"}], ":=", 
     RowBox[{"S4", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f4", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"4", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s4", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S5", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"f3", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f8", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f9", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f6", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f2", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f0", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s5", "[", "x_", "]"}], ":=", 
     RowBox[{"S5", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f5", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"6", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s5", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S6", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"f2", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f7", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f8", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f5", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f1", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f9", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s6", "[", "x_", "]"}], ":=", 
     RowBox[{"S6", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f6", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"6", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s6", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"S7", "[", "x_", "]"}], ":=", 
    RowBox[{
     RowBox[{"2", "*", 
      RowBox[{"f9", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}], "+", 
     RowBox[{"2", "*", 
      RowBox[{"f3", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}], "+", 
     RowBox[{"2", "*", 
      RowBox[{"f6", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}], "+", 
     RowBox[{"2", "*", 
      RowBox[{"f1", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s7", "[", "x_", "]"}], ":=", 
     RowBox[{"S7", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f7", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"8", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s7", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S8", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"f3", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f5", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"2", "*", 
       RowBox[{"f8", "[", 
        RowBox[{"x", "-", "1"}], "]"}]}], "+", 
      RowBox[{"f9", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f6", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f4", "[", 
       RowBox[{"x", "-", "1"}], "]"}], "+", 
      RowBox[{"f2", "[", 
       RowBox[{"x", "-", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s8", "[", "x_", "]"}], ":=", 
     RowBox[{"S8", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f8", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"8", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s8", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S9", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"2", "*", 
       RowBox[{"f5", "[", 
        RowBox[{"x", "-", "1"}], "]"}]}], "+", 
      RowBox[{"2", "*", 
       RowBox[{"f6", "[", 
        RowBox[{"x", "-", "1"}], "]"}]}], "+", 
      RowBox[{"2", "*", 
       RowBox[{"f7", "[", 
        RowBox[{"x", "-", "1"}], "]"}]}], "+", 
      RowBox[{"2", "*", 
       RowBox[{"f8", "[", 
        RowBox[{"x", "-", "1"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"s9", "[", "x_", "]"}], ":=", 
     RowBox[{"S9", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"f9", "[", "x_", "]"}], ":=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"8", ",", 
          RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s9", "[", "x", "]"}], ",", 
          RowBox[{"x", ">", "0"}]}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"fall", "[", "x_", "]"}], ":=", 
     RowBox[{"4", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f0", "[", "x", "]"}], "+", 
        RowBox[{"f4", "[", "x", "]"}], "+", 
        RowBox[{"f7", "[", "x", "]"}], "+", 
        RowBox[{"f9", "[", "x", "]"}], "+", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f1", "[", "x", "]"}], "+", 
           RowBox[{"f2", "[", "x", "]"}], "+", 
           RowBox[{"f3", "[", "x", "]"}], "+", 
           RowBox[{"f5", "[", "x", "]"}], "+", 
           RowBox[{"f6", "[", "x", "]"}], "+", 
           RowBox[{"f8", "[", "x", "]"}]}], ")"}]}]}], ")"}]}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.493867959021244*^9, 3.493867963333744*^9}, {
   3.4938681484118695`*^9, 3.4938681670368695`*^9}, {3.493868204302494*^9, 
   3.493868244208744*^9}, {3.493868277552494*^9, 3.493868286208744*^9}, {
   3.493868436583744*^9, 3.4938685011931195`*^9}, 3.4938685437556195`*^9, {
   3.4938767229103007`*^9, 3.493876782034544*^9}, {3.4938769033767405`*^9, 
   3.493876997422887*^9}, {3.493877029313308*^9, 3.4938772835304303`*^9}, {
   3.493877338170706*^9, 3.4938778202301207`*^9}, {3.493899080730507*^9, 
   3.493899431806385*^9}, {3.493900225613805*^9, 3.4939002728791275`*^9}, {
   3.4939003505973797`*^9, 3.4939003853784075`*^9}, {3.4939005850021296`*^9, 
   3.4939008293911905`*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f0", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "61", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.493898689311137*^9, 3.4938987251859074`*^9}, {
  3.4938987601231837`*^9, 3.493898781935544*^9}, {3.4938988536382103`*^9, 
  3.4938989306689672`*^9}, {3.493899534633852*^9, 3.4938995737586017`*^9}, {
  3.4938996201958046`*^9, 3.493899620898925*^9}, {3.493900090849042*^9, 
  3.493900113442648*^9}, {3.4939001440830765`*^9, 3.493900167614176*^9}, {
  3.4939024185841446`*^9, 3.4939024405996284`*^9}, {3.493903132159133*^9, 
  3.4939031585631857`*^9}, {3.4939039686334143`*^9, 3.493903980914585*^9}, {
  3.493904029351775*^9, 3.4939040294142747`*^9}, {3.4939051212041626`*^9, 
  3.493905172656958*^9}, {3.4939058182778263`*^9, 3.493905820793435*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s0", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"64", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"404", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2352", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14396", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"85608", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"517796", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3100928", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"18678652", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"112130536", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"674473028", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4052292096", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"24363059260", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"146416625608", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"880136072420", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5289934135040", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"31796930379452", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"191117281480168", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1148752620931652", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6904721644495296", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"41502080416224764", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"249454419121550536", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1499387600811533156", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9012303777214470976", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"54169920775234624508", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"325596931323543893608", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1957052909123964156484", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11763179837637449576320", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"70704484692741577032380", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"424980647547875162253000", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2554414467678390959817956", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15353718209839325468968576", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"92285989352327758305147964", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"554699756790637953989030376", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3334111969805857292825250116", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"20040215374409697554524743744", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"120454932703704392444547508860", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"724013715763753479185687774152", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4351800703873758482076059061604", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"26157196952668375750004355116224", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"157222032697970094446241356676988", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"945008274681647022461376607701096", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5680123987420391097887453757880132", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"34141297357453043045494147500104704", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"205211750282064663384318142217493820", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1233458178590607868379271969640385480", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7413898454904267644545569162492112100", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"44562427209471449530111525093614603776", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"267849624712804428316026750796987200956", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1609953181442173229777935518913492621800", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9676882128236658127786244336996756288580", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"58164453974898132897545523803937259965120", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"349606790840968577360477139785761990159100", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2101367757270545847371866145683525742304968", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12630608349096390691482791523134729651950436", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"75918299743719598745116446779812202690112064", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"456319131800948290570727320430961194505219836", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2742779418802676183331931257116639666134697576", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16485916140568906643664045557247580866432266308", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"99091246321409485797090839507196268073628087424", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"595603848388340127109393401479124024944548242364", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3579972574614338670790941398602308917096106450120", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"21518000042596321867908237678160575767151432741092", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S0", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4939001826453295`*^9, 3.4939002025045776`*^9}, {
   3.4939008577816334`*^9, 3.493900874890899*^9}, {3.4939010507803984`*^9, 
   3.4939010553584943`*^9}, 3.493901482433886*^9, {3.493901888978159*^9, 
   3.493901911274891*^9}, 3.493902340225271*^9, {3.49390247788064*^9, 
   3.493902487583703*^9}, {3.493903193654016*^9, 3.493903200715928*^9}, {
   3.4939040695858927`*^9, 3.493904082195187*^9}, {3.493905197188051*^9, 
   3.493905198406793*^9}, {3.4939053219528775`*^9, 3.4939053220935016`*^9}, {
   3.493905838887069*^9, 3.4939058438245373`*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f1", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "61", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4939010840145607`*^9, 3.493901084514558*^9}, {
   3.4939025043335953`*^9, 3.4939025089898157`*^9}, {3.493903219230013*^9, 
   3.4939032235109067`*^9}, 3.493903335177989*^9, {3.4939041689602566`*^9, 
   3.4939041822882967`*^9}, {3.4939052083911047`*^9, 
   3.4939052116567087`*^9}, {3.493905784528042*^9, 3.493905787559273*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s1", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"18", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"102", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"628", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3712", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"22508", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"134540", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"811156", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4866500", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"29281892", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"175892276", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1057614132", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6355591348", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"38206077028", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"229626895060", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1380268397268", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8296116714228", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"49865871985476", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"299724261334932", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1801549827899764", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10828472800643572", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"65086386141434020", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"391211783645273812", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2351442625161463060", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14133718657748369908", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"84953002646577478660", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"510623604597797734676", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3069185383169594594228", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"18447830865675617994740", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"110883652424162964235620", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"666483989800436543636052", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4006009078805713781588820", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"24078760752502068488834548", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"144729258539866094987375300", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"869918448124948354420965524", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5228784531499897850897054196", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"31428449063482289485202706932", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"188905740032421851984046907940", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1135448285310153697365107282388", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6824794253340606806423372041620", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"41021521803281484758490546545140", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"246566444168504440797677022552452", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1482027207031357747517686512845844", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8907962516409318396328535605462068", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"53542739172172717414138756995238900", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"321827231851544334655846972658904804", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1934394257033792736818696158655956308", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11626987312828112917507330913604244436", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"69885874340653403879993375897053978100", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"420060270210821640137112873797659285572", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2524839708656289198011245824863461385108", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15175954515315573872803767241919939256948", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"91217511615196054638559743030669833184756", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"548277501548425960592696413096580954045348", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3295509967124305718690653662384744659340500", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"19808191860407779414778635967740530612438548", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"119060318036632539281127258950557935154016756", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"715631160626921385017787538913235698641094404", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4301416009174921633031423791137172423271894804", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"25854351657602197637318724845796817076614808756", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"155401732408387436582649666848361778705622519796", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"934067067523124107992330100140637917599187990628", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5614360104676395945809177986163956952505432512596", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"33746012980167111059734881345725638814445752996948", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S1", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4939011029988146`*^9, 3.49390112396743*^9}, 
   3.493901492543196*^9, {3.4939018359941235`*^9, 3.4939018456190615`*^9}, {
   3.4939018853219323`*^9, 3.4939019007905836`*^9}, 3.493902319459779*^9, {
   3.493902551958291*^9, 3.493902558614498*^9}, 3.493902764722554*^9, {
   3.4939032379784527`*^9, 3.4939032381503134`*^9}, {3.4939033857701197`*^9, 
   3.4939033991603165`*^9}, {3.4939042283817515`*^9, 3.493904235975453*^9}, {
   3.493905247500229*^9, 3.493905248593972*^9}, {3.493905332390311*^9, 
   3.493905332562185*^9}, {3.493905801090436*^9, 3.4939058057154064`*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f2", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "62", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.493901166670282*^9, 3.4939011671546535`*^9}, {
  3.4939025806299825`*^9, 3.4939025837549624`*^9}, {3.4939034206283793`*^9, 
  3.493903424081394*^9}, {3.493904253350342*^9, 3.493904259740926*^9}, {
  3.4939052558283005`*^9, 3.4939052588439064`*^9}, {3.493905739903328*^9, 
  3.493905743434555*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s2", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"4", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"23", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"135", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"817", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4885", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"29441", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"176669", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1062881", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6385105", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"38390873", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"230711421", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1386878609", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8335525609", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"50103876569", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"301150842805", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1810138504193", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10880047236817", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"65396555308729", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"393075497809549", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2362646912611505", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14201056323731769", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"85357772867652761", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"513056448328321381", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3083808706812900385", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"18535725555772225761", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"111411961597316744825", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"669659462779641606717", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4025095818784223184849", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"24193484493429269474377", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"145418824621487667622873", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"874063193632758791174293", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5253697197536593114867009", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"31578190616583904081856241", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"189805785777008326023164473", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1140858154460684926170034669", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6857311141760816326532336113", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"41216969778722861000256408665", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"247741215624826497138166900505", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1489088359467685454777890742213", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8950404707205861467566321556321", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"53797844774830363186415436508161", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"323360585044133702086249312835577", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1943610722620696055882709071517597", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11682384359273213463544529384236817", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"70218847184043004899220871702524265", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"422061656956139125497222892040907353", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2536869365076615748981737505611154165", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15248260696992851571431586433779475073", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"91652119531299288004968408912821732369", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"550889782218875368815736974409828008889", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3311211499581832932891920775841955954509", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"19902568442644179169665013528412431461169", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"119627583639440632154872363575564600944505", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"719040801625841802869417129072536091404697", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4321910203929420245233901538115048498019877", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"25977535306194290115030762503776869636540065", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"156142147509454560962961884924752534679059233", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"938517451386196554110939665848031503102992761", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5641109851541555736369423036318121986336122109", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"33906796629255822100348735007164873594316333649", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"203802245996599439578478443111521378491989883529", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1224986126746650062867206848605509981203477303513", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7362975826806135785415313646593540474832654085461", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"44256348576055224336614655482992412697797197009857", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S2", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4939012413416786`*^9, 3.493901292872599*^9}, {
   3.4939013568878145`*^9, 3.493901357106563*^9}, 3.4939014989962797`*^9, {
   3.4939019367591033`*^9, 3.493901943087188*^9}, 3.493902294897436*^9, {
   3.493902632004654*^9, 3.4939026330983963`*^9}, {3.493902814769109*^9, 
   3.4939028170659695`*^9}, {3.493903469798681*^9, 3.493903484704454*^9}, {
   3.4939035437806883`*^9, 3.4939035554991684`*^9}, {3.493904288678241*^9, 
   3.4939042969906874`*^9}, {3.4939053031873727`*^9, 
   3.4939053041248665`*^9}, {3.4939053462027225`*^9, 
   3.4939053468745933`*^9}, {3.4939057572938414`*^9, 3.4939057619656863`*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f3", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "63", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.493901187701397*^9, 3.493901188295143*^9}, {
  3.493902638863985*^9, 3.493902642020214*^9}, {3.4939035148909883`*^9, 
  3.4939035207658*^9}, {3.493904310178103*^9, 3.4939043269592457`*^9}, {
  3.4939053591245146`*^9, 3.493905363171364*^9}, {3.4939056999504585`*^9, 
  3.4939057061847935`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s3", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"4", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"26", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"146", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"918", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5382", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"32850", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"195730", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1182622", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7086926", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"42672954", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"256227370", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1541031494", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9259336326", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"55666279682", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"334550560098", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2011012520174", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12087012586814", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"72652692106186", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"436684481590618", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2624783965427222", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15776609033707062", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"94828110910652434", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"569978643515952274", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3425951487006323390", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"20592219889412535662", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"123772885435056894170", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"743956659531306186250", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4471671475775335144934", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"26877697698341794726374", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"161552724379490241191714", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"971038570503907678965442", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5836583337686311764667022", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"35081721135598636776211102", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"210864319370430669527236586", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1267433849450897441814634426", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7618114692308179895920281526", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"45789901656642236687795726998", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"275227557134645969228556063794", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1654299428522913613421926069746", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9943432369368560251956373528670", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"59766596996349873538361501290702", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"359236728770611290220600488462586", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2159250045523298236273826639536746", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12978519137827715801136075811167110", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"78009473406996713221861817117167686", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"468888466914487646351501198158624578", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2818329425912726060078462334456027682", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16940021590395499446724694801682127918", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"101820720049078367245800556556050507774", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"612009788536198237952100784334790337546", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3678583112386954104623323134289660188186", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"22110714515064884749690024356445286416726", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"132900000198514054166685602858075385191158", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"798816792679209529233901918664559165800530", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4801416608826564489155437228354124910703442", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"28859685553425281928496003686697652823582206", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"173465774394880126010813247888528526888652846", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1042643892661714890881177866297764559552243994", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6266978547768440021505706662317515345713500874", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"37668680931825110326122767611429644142537384230", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"226413655692006702952987951878976350782518899366", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1360895635729789878739601359438392259150197532514", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8179881755311321527523884979907446233815643814274", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"49166492840572526095809834853544825319433701426638", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S3", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4939013006225495`*^9, 3.493901300638174*^9}, {
   3.4939013495128613`*^9, 3.493901372715838*^9}, 3.4939014074968653`*^9, {
   3.493901458762162*^9, 3.4939014590902853`*^9}, 3.493901507714974*^9, {
   3.493901965899542*^9, 3.4939019750713577`*^9}, 3.4939022638351345`*^9, {
   3.4939027207384605`*^9, 3.49390273253526*^9}, {3.4939035961233883`*^9, 
   3.4939035964515066`*^9}, {3.4939036485911307`*^9, 
   3.4939036489661236`*^9}, {3.493904363318388*^9, 3.4939043726308284`*^9}, {
   3.4939054048273473`*^9, 3.4939054103116875`*^9}, {3.4939057217471943`*^9, 
   3.493905726887786*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f4", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "51", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4939011903732553`*^9, 3.4939011904982543`*^9}, {
  3.4939026539263887`*^9, 3.4939026564107475`*^9}, {3.493903611763713*^9, 
  3.4939036152636456`*^9}, {3.493904387802606*^9, 3.4939043941619406`*^9}, {
  3.493905430514683*^9, 3.4939054417958603`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s4", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"4", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"24", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"148", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"880", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5348", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"31976", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"192908", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1157232", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6964340", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"41831400", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"251539468", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1511557360", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9086748596", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"54612878280", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"328275362860", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1973096259760", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11859807861876", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"71284592884328", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"428469911236364", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2575378717626800", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15479757210239348", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"93043461600909384", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"559253036024063532", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3361478883537116144", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"20204713182348888500", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"121443657105061574504", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"729956659105397644684", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4387521520405058178928", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"26371903355218237331252", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"158512557553292371147720", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"952765190191367578873644", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5726748143387570164722736", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"34421539440557079598153716", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"206896189949967171805167976", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1243582775024032457859767564", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7474753962976740076248883760", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"44928209029373648839551646196", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"270048215022497617989222057032", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1623168161755890857271031818540", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9756312888807524558008867762544", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"58641885319025226823328864946996", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"352476468593493855744250449666152", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2118616416254347508162995408049548", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12734284183652807043214296261757424", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"76541459996280477287723633463699892", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"460064736566601010449641090801054152", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2765292977731910276956968936669037612", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16621237501792335311466378238563462064", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"99904617093416204076571331363179682676", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"600492744026833952854702948914660947048", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3609358066923940861454185286721750587148", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"21694626262932343001438162238777086690992", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"130399034942386530580255832359638871332468", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"783784339394542949419573488756158979810376", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4711061634402425119651770022949817496227884", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"28316592470171220322467691009087998359591664", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"170201426206448403182307869983254570035257524", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1023023003676175639924755924569596252776013160", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6149044043738927252442526585342553913433403788", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"36959816657074415039395618200023546134864468080", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"222152913137038650227605815819143481163170000948", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1335285758400162465179283570626109117998173764552", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8025949475109665943513875138450268302953269550380", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"48241258151507034455921401794445231122638952349488", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S4", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.493901303575656*^9, 3.4939013035912805`*^9}, {
   3.49390134587226*^9, 3.4939013752783213`*^9}, 3.4939014106999702`*^9, {
   3.4939014556215577`*^9, 3.4939014557621813`*^9}, 3.493901512418069*^9, {
   3.4939019967587194`*^9, 3.4939020035399256`*^9}, 3.4939022433977656`*^9, {
   3.4939028558782206`*^9, 3.493902861300061*^9}, {3.493903636591361*^9, 
   3.493903665247061*^9}, {3.4939044374272885`*^9, 3.4939044380991592`*^9}, {
   3.493905462686352*^9, 3.493905469576933*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f5", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "51", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4939011925451164`*^9, 3.4939011926388655`*^9}, {
  3.4939026640669484`*^9, 3.4939026667544312`*^9}, {3.493903678403058*^9, 
  3.4939036808561363`*^9}, {3.4939044516771975`*^9, 3.4939044552240496`*^9}, {
  3.4939045666295867`*^9, 3.4939045668952103`*^9}, {3.4939046004262457`*^9, 
  3.493904600863743*^9}, {3.4939054750300226`*^9, 3.493905478904998*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s5", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"6", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"32", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"202", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1176", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7198", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"42804", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"258898", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1550464", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9339326", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"56065268", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"337236514", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2026146048", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12181529630", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"73208312804", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"440068036210", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2644967067520", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15898465189726", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"95558640740084", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"574376310465826", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3452360822247648", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"20751040208112382", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"124727209560775268", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"749693800405766578", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4506151888607235488", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"27084960387617312254", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"162798465661771946804", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"978526454561982078242", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5881589918818724788160", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"35352242346370788516190", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"212490323773937581126500", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1277207233839195479908978", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7676859104919662734484288", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"46142994676163879152573982", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"277349878395318976994515188", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1667055984902928646412625058", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10020107687204848777262371872", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"60227466351852196222273754430", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"362006857881876739592843887076", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2175900351936879241038029530802", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"13078598476334187875002177558112", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"78611016348985047223120678338494", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"472504137340823511230688303850548", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2840061993710195548943726878940066", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"17070648678726521522747073750052352", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"102605875141032331692159071108746910", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"616729089295303934189635984820192740", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3706949227452133822272784581246056050", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"22281213604735724765055762546807301888", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"133924812356402214158013375398493600478", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"804976590721086614888967759456746310900", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4838441064118329063893122168498378144290", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"29082226987449066448772761901968629982560", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"174803395420484288680238569892880995079550", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1050683878635272923685933072841762871152484", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6315304174548195345741395761567364825975218", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"37959149871859799372558223389906101345056032", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"228159565900474145285363660215480597252609918", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1371389709401338091665965628558319833067348788", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8242958070284453321832022778623790433216133154", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"49545623160704742898545419753598134036814043712", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"297801924194170063554696700739562012472274121182", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1789986287307169335395470699301154458548053225060", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10759000021298160933954118839080287883575716370546", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"64668697340936380063291054776144150131813343830208", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S5", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4939013071537576`*^9, 3.4939013071693826`*^9}, {
   3.493901343216027*^9, 3.4939013433722763`*^9}, 3.4939013773408084`*^9, 
   3.493901412246835*^9, {3.4939014490434747`*^9, 3.4939014492153482`*^9}, 
   3.4939015183086567`*^9, {3.4939022187416735`*^9, 3.493902223022896*^9}, {
   3.49390288961238*^9, 3.493902897252956*^9}, {3.493903726402137*^9, 
   3.493903731495789*^9}, {3.493904642535351*^9, 3.493904649879054*^9}, {
   3.493905500795483*^9, 3.493905511889162*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f6", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "53", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.493901194623228*^9, 3.493901194732602*^9}, {
  3.4939026740668845`*^9, 3.493902676644993*^9}, {3.4939037498391867`*^9, 
  3.493903752526635*^9}, {3.493904669472678*^9, 3.493904690831917*^9}, {
  3.4939055214672256`*^9, 3.4939055244672065`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s6", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"6", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"37", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"219", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1325", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7925", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"47753", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"286557", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1723937", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10356273", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"62267481", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"374198509", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2249422625", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"13519652777", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"81265051225", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"488446003141", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2935920361265", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"17646689549425", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"106068721571993", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"637541463587965", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3832051033891905", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"23033138092149177", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"138444445524732761", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"832142324509254197", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5001725937835406353", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"30063673888832811073", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"180702550353650253081", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1086141658953220468717", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6528428989607166571297", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"39240170331136870264457", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"235859346718464697567065", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1417670472707083687926053", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8521136050266299531373297", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"51217656508957429255383057", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"307851949383914294785496985", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1850393576695466729388938077", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11122087737639469848241441025", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"66851094354885439123875137625", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"401819237810087403794040101721", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2415199054077979863580676931605", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14516941755011515345281827963601", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"87256409591470115770874364409569", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"524468661754805639993446529552409", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3152403112228554881749794501108941", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"18948025128594642137419521426327009", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"113890147766630284387966335653562153", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"684555021978299988009271277956162393", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4114627887523483416685378909051759365", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"24731631657422847730844344572502472625", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"148653443557481141596179305213000464561", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"893505393724152485090848283561465402009", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5370557650790343511664887549951708774461", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"32280599180547611292857942608301882455489", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"194027725091404039007517674628981158426361", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1166234799223718330363288959366355090508633", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7009841538262743378520304803634885882131957", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"42133778227388062512967094262176270527518097", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"253251840005882175592884032285723371197012353", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1522210852305547524345584442473054057463221017", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9149492769027679647293185999709653016109572525", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"54994495541598284254934158213984330939513414817", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"330553246636018033093206647583507981809012679625", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1986843370150799249010176637365006206358975627097", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11942241129638471756414542740432998534212215766245", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"71780758031069308506230007441144741088171409827953", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S6", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4939013147474594`*^9, 3.4939013406691685`*^9}, 
   3.493901380684537*^9, {3.4939014226530185`*^9, 3.4939014460747433`*^9}, 
   3.493901522011758*^9, {3.4939021979449315`*^9, 3.493902201944906*^9}, {
   3.4939029105809956`*^9, 3.493902914721594*^9}, {3.4939037703075438`*^9, 
   3.49390377491683*^9}, {3.4939047314722815`*^9, 3.4939047376128674`*^9}, {
   3.4939055417170963`*^9, 3.4939055479045563`*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f7", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "56", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.493901197154462*^9, 3.4939011973732104`*^9}, {
  3.493902680801216*^9, 3.493902683473074*^9}, {3.4939037891353073`*^9, 
  3.4939038086974316`*^9}, {3.493904764706444*^9, 3.4939047805188427`*^9}, {
  3.4939055620450907`*^9, 3.4939055657169423`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s7", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"8", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"42", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"274", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1570", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9698", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"57346", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"347930", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2079682", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12540514", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"75233922", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"452704202", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2719290114", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16350898642", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"98257967266", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"590671551322", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3550057848770", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"21339135199234", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"128258984454210", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"770932866502250", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4633774854140162", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"27852191725553074", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"167409565252888290", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1006243852323887482", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6048184013100063170", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"36353603201972441826", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"218509092646830736770", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1313384261436732518794", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7894306057284228238594", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"47449997599596824496786", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"285205818460484178446114", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1714275412465871302488474", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10303927504699175842594242", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"61933411414324761650136002", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"372260712964025733612304066", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2237532800343746195338081450", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"13449050184082003310428929794", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"80837675898813551859915361650", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"485887831875239796432900280162", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2920506839794941488064804367802", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"17554175341064107945642397025218", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"105512189802203961840387221634722", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"634197960232418405437990670457858", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3811948681560067458696032032835530", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"22912329684304861813174706184675074", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"137718236900871045368659765302818386", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"827777578099353623312201988658886562", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4975490060228013751840214498941330906", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"29905981986237704577717444890772030402", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"179754707122041210535965159671837088642", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1080444532713261344104660566892167974210", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6494185364943397428246958916126274527978", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"39034343992004264176036786893955519268098", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"234622192817581289430306374892035194674482", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1410234366274745585457947573945853477427170", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8476440118215615791024429625990596232286714", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"50949004503050186653129402184604794989958594", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"306237173111584648461941621702759792765022818", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1840687705483177554574899682816086862705681026", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11063749037032962253656115809769042074169114122", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"66500440237533330227366773627212574171792771330", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"399711574890506635320645009445608557298185427474", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2402530607778946633931794500193440764942979581986", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14440796023722503517905024958699099805400883145242", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"86798723447500211704914323599594176729772366893506", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S7", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4939013177474403`*^9, 3.4939013367941933`*^9}, 
   3.4939013821220284`*^9, {3.4939014240748844`*^9, 3.493901441793521*^9}, 
   3.493901528324217*^9, {3.493902172273221*^9, 3.4939021770231905`*^9}, {
   3.49390293412772*^9, 3.4939029421120443`*^9}, {3.4939038420405416`*^9, 
   3.4939038471029444`*^9}, {3.493904871924508*^9, 3.493904877533847*^9}, {
   3.493905585560566*^9, 3.493905601919836*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f8", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "56", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.493901200998187*^9, 3.4939012012481856`*^9}, {
  3.4939026887386656`*^9, 3.493902691363649*^9}, {3.4939038591966143`*^9, 
  3.49390386218097*^9}, {3.4939048959868536`*^9, 3.493904900658699*^9}, {
  3.493904964877038*^9, 3.493904965048912*^9}, {3.4939056074510503`*^9, 
  3.493905610279157*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s8", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"8", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"48", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"294", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1756", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10606", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"63604", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"382886", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2299548", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"13828774", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"83096780", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"499551310", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3002342804", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"18047102814", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"108471401748", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"651997569782", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3918891410764", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"23555283855350", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"141582263511996", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"851004877222782", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5115094639692452", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"30745121766747630", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"184798407101379332", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1110760798252605798", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6676405104168120860", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"40129608663118251590", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"241205444117641928172", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1449804100671222903214", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8714280201833783520692", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"52378581078304390847486", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"314829870716193548245108", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1892335501189877403395926", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11374186382592228034409836", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"68366373839384949126372886", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"410927068141585559402647196", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2469943132037472596309807454", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14845989822378644523855541572", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"89234205854606572306815301518", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"536356523743299459406959845476", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3223857015880848665582507811526", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"19377510290144053159708058944828", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"116471637300397054333763723542374", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"700071479356562463860897215562188", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4207892046303105285333321491341966", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"25292210860312522842725740920682836", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"152022894876303792002958728283359390", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"913758021951467492126983270175894228", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5492289324983441595654726784825703350", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"33012286956312602591560970879907713420", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"198425651964338609181550917901279965750", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1192669244925772192774991859026084956028", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7168730019079217396095757985098883157310", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"43088802956128380540437891823374149249508", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"258992169498757420543101141520004104714030", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1556714024522003030591983092810349582313412", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9356879626259045672078408276189874269092390", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"56241027549798919662657931304929632194046556", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"338045727443207693951564714396269599499353734", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2031878129207748735340085426373512397164457900", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12212929780768767498192102437694257721718733166", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"73407775636694214787680140298142096439047616244", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"441229223508074529636653833434078208216567982910", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2652079101825043093017336209786741892326437242676", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15940747320442195700436815917315169327503832360470", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"95814421583172063970404923272387566728750055661484", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S8", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.493901320153674*^9, 3.493901333997336*^9}, 
   3.493901384543887*^9, {3.493901428574856*^9, 3.493901438637291*^9}, 
   3.4939015321835675`*^9, {3.493902146335887*^9, 3.493902158179561*^9}, {
   3.4939029912958536`*^9, 3.493902996889138*^9}, {3.4939038885714264`*^9, 
   3.4939038945088882`*^9}, {3.4939050023611727`*^9, 
   3.4939050086423826`*^9}, {3.4939056227009525`*^9, 3.493905630497778*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f9", "[", "n", "]"}], ",", 
     RowBox[{"x", "\[Equal]", "n"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "60", ",", "63"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4939012039200435`*^9, 3.493901204185667*^9}, {
  3.493902696582365*^9, 3.493902699582346*^9}, {3.4939039055869427`*^9, 
  3.4939039140087633`*^9}, {3.493905026376644*^9, 3.4939050490014997`*^9}, {
  3.493905636794613*^9, 3.4939056397945933`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s9", "[", "x_", "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"8", ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"56", ",", 
        RowBox[{"x", "\[Equal]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"318", ",", 
        RowBox[{"x", "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1978", ",", 
        RowBox[{"x", "\[Equal]", "3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11654", ",", 
        RowBox[{"x", "\[Equal]", "4"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"70854", ",", 
        RowBox[{"x", "\[Equal]", "5"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"423014", ",", 
        RowBox[{"x", "\[Equal]", "6"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2552542", ",", 
        RowBox[{"x", "\[Equal]", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15307262", ",", 
        RowBox[{"x", "\[Equal]", "8"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"92129774", ",", 
        RowBox[{"x", "\[Equal]", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"553326902", ",", 
        RowBox[{"x", "\[Equal]", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3327381070", ",", 
        RowBox[{"x", "\[Equal]", "11"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"19994403182", ",", 
        RowBox[{"x", "\[Equal]", "12"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"120198367726", ",", 
        RowBox[{"x", "\[Equal]", "13"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"722405466086", ",", 
        RowBox[{"x", "\[Equal]", "14"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4342366320910", ",", 
        RowBox[{"x", "\[Equal]", "15"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"26099673376638", ",", 
        RowBox[{"x", "\[Equal]", "16"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"156879147587470", ",", 
        RowBox[{"x", "\[Equal]", "17"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"942937220556566", ",", 
        RowBox[{"x", "\[Equal]", "18"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5667711035557646", ",", 
        RowBox[{"x", "\[Equal]", "19"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"34066562699944334", ",", 
        RowBox[{"x", "\[Equal]", "20"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"204762983585124526", ",", 
        RowBox[{"x", "\[Equal]", "21"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1230759254879551302", ",", 
        RowBox[{"x", "\[Equal]", "22"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7397681550983028110", ",", 
        RowBox[{"x", "\[Equal]", "23"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"44464933887421651742", ",", 
        RowBox[{"x", "\[Equal]", "24"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"267263692283081633486", ",", 
        RowBox[{"x", "\[Equal]", "25"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1606431105559789729654", ",", 
        RowBox[{"x", "\[Equal]", "26"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9655712951246315937934", ",", 
        RowBox[{"x", "\[Equal]", "27"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"58037210335087806237486", ",", 
        RowBox[{"x", "\[Equal]", "28"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"348841982710817748249838", ",", 
        RowBox[{"x", "\[Equal]", "29"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2096770719338160010769574", ",", 
        RowBox[{"x", "\[Equal]", "30"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12602977240404055747438862", ",", 
        RowBox[{"x", "\[Equal]", "31"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"75752218084954732285723326", ",", 
        RowBox[{"x", "\[Equal]", "32"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"455320872877662038368931854", ",", 
        RowBox[{"x", "\[Equal]", "33"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2736779217769689129589926870", ",", 
        RowBox[{"x", "\[Equal]", "34"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16449850987959228334898904078", ",", 
        RowBox[{"x", "\[Equal]", "35"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"98874470862609932919576568526", ",", 
        RowBox[{"x", "\[Equal]", "36"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"594300884920315519025759110446", ",", 
        RowBox[{"x", "\[Equal]", "37"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3572140902621006798453488228870", ",", 
        RowBox[{"x", "\[Equal]", "38"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"21470926523381298516532037283470", ",", 
        RowBox[{"x", "\[Equal]", "39"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"129054451725107728651268922983518", ",", 
        RowBox[{"x", "\[Equal]", "40"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"775702506086112358336291975850318", ",", 
        RowBox[{"x", "\[Equal]", "41"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4662484477369220041046045438846006", ",", 
        RowBox[{"x", "\[Equal]", "42"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"28024611667603846349445749808453006", ",", 
        RowBox[{"x", "\[Equal]", "43"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"168446428703877096632134084563474542", ",", 
        RowBox[{"x", "\[Equal]", "44"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1012474309369674906903487800696973678", ",", 
        RowBox[{"x", "\[Equal]", "45"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6085639422648850075276185043222271846", ",", 
        RowBox[{"x", "\[Equal]", "46"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"36578713000374145172906209548129699342", ",", 
        RowBox[{"x", "\[Equal]", "47"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"219862228409417759330357045779979036670", ",", 
        RowBox[{"x", "\[Equal]", "48"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1321517230000526350943417516369222238862", ",", 
        RowBox[{"x", "\[Equal]", "49"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7943191524168545273718936937872929286294", ",", 
        RowBox[{"x", "\[Equal]", "50"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"47743828197862574799801453239350489208078", ",", 
        RowBox[{"x", "\[Equal]", "51"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"286971946232258644916210766455200361911310", ",", 
        RowBox[{"x", "\[Equal]", "52"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1724890965656454075322327521867802905788846", ",", 
        RowBox[{"x", "\[Equal]", "53"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10367734137311479740198305397928642042803398", ",", 
        RowBox[{"x", "\[Equal]", "54"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"62316930914571200374729076934765442418972558", ",", 
        RowBox[{"x", "\[Equal]", "55"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"374565920304193936402625302283233598113158558", ",", 
        RowBox[{"x", "\[Equal]", "56"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2251388612922297326583508057200466721427997646", ",", 
        RowBox[{"x", "\[Equal]", "57"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"13532332792795623811853070360441946300801417462", ",", 
        RowBox[{"x", "\[Equal]", "58"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"81338259314227725441946854051593486490427105934", ",", 
        RowBox[{"x", "\[Equal]", "59"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"488896669153061144337052983785874271174335692206", ",", 
        RowBox[{"x", "\[Equal]", "60"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2938591938457538523210404382405513519592080422382", ",", 
        RowBox[{"x", "\[Equal]", "61"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"17662878734123916622709556093292686644352891353638", ",", 
        RowBox[{"x", "\[Equal]", "62"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"106165568990202663817421004911055111101385295285006", ",", 
        RowBox[{"x", "\[Equal]", "63"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S9", "[", "x", "]"}], ",", 
        RowBox[{"x", ">", "63"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4939013220442877`*^9, 3.4939013262317605`*^9}, 
   3.4939013893876066`*^9, {3.4939014316217113`*^9, 3.493901435949808*^9}, 
   3.493901537214785*^9, {3.493902108289255*^9, 3.493902113554847*^9}, {
   3.4939030089037633`*^9, 3.493903013137786*^9}, {3.49390393494613*^9, 
   3.49390394033672*^9}, {3.493905077501317*^9, 3.4939050843137736`*^9}, {
   3.49390565352888*^9, 3.4939056581851006`*^9}}],

Cell[BoxData[
 RowBox[{"fall", "[", "63", "]"}]], "Input",
 CellChangeTimes->{{3.493905859215064*^9, 3.4939058798868065`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["3926356053343005839641342729308535057127083875101072."], "Input",
 CellChangeTimes->{{3.4939079896919594`*^9, 3.4939079897075844`*^9}}],

Cell[BoxData["3.926356053343005839641342729308535057127083875101072`51.\
59398968013171*^51"], "Output",
 CellChangeTimes->{3.493907989973206*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"3926356053343005839641342729308535057127083875101072.", "/", 
  RowBox[{"(", 
   RowBox[{"12", "*", 
    RowBox[{"(", 
     RowBox[{"10", "^", "18"}], ")"}], "*", "2", "*", 
    RowBox[{"10", "^", "13"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.493905922745908*^9, 3.4939059227615323`*^9}, {
  3.4939066201164446`*^9, 3.4939066639442887`*^9}, {3.4939067262720146`*^9, 
  3.4939067418656654`*^9}, {3.4939067774591875`*^9, 3.4939068102402277`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(", "1.6359816888929190998505594705452229404696182812921133333333333333333`\
51.59398968013171*^19", ")"}], "/", 
  RowBox[{"(", 
   RowBox[{"6.20873081", "\[Times]", 
    RowBox[{"10", "^", "18"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.493908189876897*^9, 3.4939082154390697`*^9}}],

Cell[BoxData["2.6349695919461507`"], "Output",
 CellChangeTimes->{{3.493908206532934*^9, 3.4939082169703007`*^9}}]
}, Open  ]]
},
WindowSize->{615, 750},
WindowMargins->{{48, Automatic}, {Automatic, 38}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 13089, 376, 1152, "Input"],
Cell[13637, 398, 926, 17, 31, "Input"],
Cell[14566, 417, 8938, 210, 992, InheritFromParent],
Cell[23507, 629, 606, 13, 31, "Input"],
Cell[24116, 644, 8978, 210, 992, InheritFromParent],
Cell[33097, 856, 576, 13, 31, "Input"],
Cell[33676, 871, 9022, 211, 992, InheritFromParent],
Cell[42701, 1084, 572, 13, 31, "Input"],
Cell[43276, 1099, 8999, 211, 992, InheritFromParent],
Cell[52278, 1312, 529, 12, 31, "Input"],
Cell[52810, 1326, 8890, 209, 992, InheritFromParent],
Cell[61703, 1537, 632, 13, 31, "Input"],
Cell[62338, 1552, 8894, 209, 992, InheritFromParent],
Cell[71235, 1763, 523, 12, 31, "Input"],
Cell[71761, 1777, 8831, 208, 1012, InheritFromParent],
Cell[80595, 1987, 527, 12, 31, "Input"],
Cell[81125, 2001, 8830, 208, 1012, InheritFromParent],
Cell[89958, 2211, 573, 13, 31, "Input"],
Cell[90534, 2226, 8831, 208, 1012, InheritFromParent],
Cell[99368, 2436, 525, 12, 31, "Input"],
Cell[99896, 2450, 8831, 208, 1012, InheritFromParent],
Cell[108730, 2660, 126, 2, 31, "Input"],
Cell[CellGroupData[{
Cell[108881, 2666, 149, 1, 31, InheritFromParent],
Cell[109033, 2669, 146, 2, 30, "Output"]
}, Open  ]],
Cell[109194, 2674, 473, 9, 52, InheritFromParent],
Cell[CellGroupData[{
Cell[109692, 2687, 325, 8, 52, InheritFromParent],
Cell[110020, 2697, 114, 1, 30, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
